# pyright: reportUnusedImport=false
from . import abcs, types
from .core import Serializable, Reader, deserialize_bool, deserialize_i32_list, deserialize_i64_list, deserialize_identity, single_deserializer, list_deserializer
from typing import cast, Type
LAYER = None
TYPE_MAPPING = {t.constructor_id(): t for t in cast(tuple[Type[Serializable]], (
  types.AccessPointRule,
  types.BadMsgNotification,
  types.BadServerSalt,
  types.BindAuthKeyInner,
  types.ClientDhInnerData,
  types.DestroyAuthKeyFail,
  types.DestroyAuthKeyNone,
  types.DestroyAuthKeyOk,
  types.DestroySessionNone,
  types.DestroySessionOk,
  types.DhGenFail,
  types.DhGenOk,
  types.DhGenRetry,
  types.FutureSalt,
  types.FutureSalts,
  types.GzipPacked,
  types.HttpWait,
  types.IpPort,
  types.IpPortSecret,
  types.Message,
  types.MsgContainer,
  types.MsgDetailedInfo,
  types.MsgNewDetailedInfo,
  types.MsgResendReq,
  types.MsgsAck,
  types.MsgsAllInfo,
  types.MsgsStateInfo,
  types.MsgsStateReq,
  types.NewSessionCreated,
  types.PQInnerData,
  types.PQInnerDataDc,
  types.PQInnerDataTemp,
  types.PQInnerDataTempDc,
  types.Pong,
  types.ResPq,
  types.RpcAnswerDropped,
  types.RpcAnswerDroppedRunning,
  types.RpcAnswerUnknown,
  types.RpcError,
  types.RpcResult,
  types.ServerDhInnerData,
  types.ServerDhParamsFail,
  types.ServerDhParamsOk,
  types.help.ConfigSimple,
))}
RESPONSE_MAPPING = {
  0x60469778: single_deserializer(abcs.ResPq),
  0xbe7e8ef1: single_deserializer(abcs.ResPq),
  0xd712e4be: single_deserializer(abcs.ServerDhParams),
  0xf5045f1f: single_deserializer(abcs.SetClientDhParamsAnswer),
  0xd1435160: single_deserializer(abcs.DestroyAuthKeyRes),
  0x58e4a740: single_deserializer(abcs.RpcDropAnswer),
  0xb921bd04: single_deserializer(abcs.FutureSalts),
  0x7abe77ec: single_deserializer(abcs.Pong),
  0xf3427b8c: single_deserializer(abcs.Pong),
  0xe7512126: single_deserializer(abcs.DestroySessionRes),
}
__all__ = ['LAYER', 'TYPE_MAPPING', 'RESPONSE_MAPPING']
